/[gentoo-x86]/eclass/flag-o-matic.eclass
Gentoo

Diff of /eclass/flag-o-matic.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.43 Revision 1.106
1# Copyright 1999-2003 Gentoo Technologies, Inc. 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.43 2004/04/06 04:25:16 tseng Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/flag-o-matic.eclass,v 1.106 2006/02/19 23:18:30 vapier Exp $
4#
5# Author Bart Verwilst <verwilst@gentoo.org>
6 4
7ECLASS=flag-o-matic 5
8INHERITED="$INHERITED $ECLASS" 6# need access to emktemp()
7inherit eutils toolchain-funcs multilib
9 8
10# 9#
11#### filter-flags <flags> #### 10#### filter-flags <flags> ####
12# Remove particular flags from C[XX]FLAGS 11# Remove particular flags from C[XX]FLAGS
13# Matches only complete flags 12# Matches only complete flags
16# Add extra flags to your current C[XX]FLAGS 15# Add extra flags to your current C[XX]FLAGS
17# 16#
18#### replace-flags <orig.flag> <new.flag> ### 17#### replace-flags <orig.flag> <new.flag> ###
19# Replace a flag by another one 18# Replace a flag by another one
20# 19#
21#### replace-cpu-flags <new.cpu> <old.cpus> ### 20#### replace-cpu-flags <old.cpus> <new.cpu> ###
22# Replace march/mcpu flags that specify <old.cpus> 21# Replace march/mcpu flags that specify <old.cpus>
23# with flags that specify <new.cpu> 22# with flags that specify <new.cpu>
24# 23#
25#### is-flag <flag> #### 24#### is-flag[q] <flag> ####
26# Returns "true" if flag is set in C[XX]FLAGS 25# Returns "true" if flag is set in C[XX]FLAGS
27# Matches only complete a flag 26# Matches only complete a flag
27# q version sets return code but doesn't echo
28#
29#### is-ldflag[q] <flag> ####
30# Returns "true" if flag is set in LDFLAGS
31# Matches only complete a flag
32# q version sets return code but doesn't echo
28# 33#
29#### strip-flags #### 34#### strip-flags ####
30# Strip C[XX]FLAGS of everything except known 35# Strip C[XX]FLAGS of everything except known
31# good options. 36# good options.
32# 37#
51# 56#
52#### filter-ldflags <flags> #### 57#### filter-ldflags <flags> ####
53# Remove particular flags from LDFLAGS 58# Remove particular flags from LDFLAGS
54# Matches only complete flags 59# Matches only complete flags
55# 60#
56#### etexec-flags #### 61#### bindnow-flags ####
57# hooked function for hardened-gcc that appends 62# Returns the flags to enable "now" binding in the current selected linker.
58# -yet_exec {C,CXX,LD}FLAGS when hardened-gcc is installed
59# and a package is filtering -fPIC,-fpic, -fPIE, -fpie
60# 63#
61#### fstack-flags #### 64################ DEPRECATED functions ################
62# hooked function for hardened-gcc that appends 65# The following are still present to avoid breaking existing
63# -yno_propolice to {C,CXX,LD}FLAGS when hardened-gcc is installed 66# code more than necessary; however they are deprecated. Please
64# and a package is filtering -fstack-protector, -fstack-protector-all 67# use gcc-specs-* from toolchain-funcs.eclass instead, if you
68# need to know which hardened techs are active in the compiler.
69# See bug #100974
70#
71#### has_hardened ####
72# Returns true if the compiler has 'Hardened' in its version string,
73# (note; switched-spec vanilla compilers satisfy this condition) or
74# the specs file name contains 'hardened'.
75#
76#### has_pie ####
77# Returns true if the compiler by default or with current CFLAGS
78# builds position-independent code.
79#
80#### has_pic ####
81# Returns true if the compiler by default or with current CFLAGS
82# builds position-independent code.
83#
84#### has_ssp_all ####
85# Returns true if the compiler by default or with current CFLAGS
86# generates stack smash protections for all functions
87#
88#### has_ssp ####
89# Returns true if the compiler by default or with current CFLAGS
90# generates stack smash protections for most vulnerable functions
65# 91#
66 92
67# C[XX]FLAGS that we allow in strip-flags 93# C[XX]FLAGS that we allow in strip-flags
68setup-allowed-flags() { 94setup-allowed-flags() {
69 export ALLOWED_FLAGS="-O -O1 -O2 -mcpu -march -mtune -fstack-protector -pipe -g" 95 if [[ -z ${ALLOWED_FLAGS} ]] ; then
70 case "${ARCH}" in 96 export ALLOWED_FLAGS="-pipe"
71 mips) ALLOWED_FLAGS="${ALLOWED_FLAGS} -mips1 -mips2 -mips3 -mips4 -mabi" ;; 97 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -O -O0 -O1 -O2 -mcpu -march -mtune"
72 amd64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 98 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fstack-protector -fstack-protector-all"
73 alpha) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 99 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fbounds-checking -fno-bounds-checking"
74 ia64) ALLOWED_FLAGS="${ALLOWED_FLAGS} -fPIC" ;; 100 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-PIE -fno-pie -fno-unit-at-a-time"
75 esac 101 export ALLOWED_FLAGS="${ALLOWED_FLAGS} -g -g0 -g1 -g2 -g3 -ggdb -ggdb0 -ggdb1 -ggdb2 -ggdb3"
102 fi
103 # allow a bunch of flags that negate features / control ABI
104 ALLOWED_FLAGS="${ALLOWED_FLAGS} -fno-stack-protector -fno-stack-protector-all"
105 ALLOWED_FLAGS="${ALLOWED_FLAGS} -mregparm -mno-app-regs -mapp-regs \
106 -mno-mmx -mno-sse -mno-sse2 -mno-sse3 -mno-3dnow \
107 -mips1 -mips2 -mips3 -mips4 -mips32 -mips64 -mips16 \
108 -msoft-float -mno-soft-float -mhard-float -mno-hard-float -mfpu \
109 -mieee -mieee-with-inexact \
110 -mtls-direct-seg-refs -mno-tls-direct-seg-refs \
111 -mflat -mno-flat -mno-faster-structs -mfaster-structs \
112 -m32 -m64 -mabi -mlittle-endian -mbig-endian -EL -EB -fPIC \
113 -mlive-g0 -mcmodel -mstack-bias -mno-stack-bias"
76 114
77 # C[XX]FLAGS that we are think is ok, but needs testing 115 # C[XX]FLAGS that we are think is ok, but needs testing
78 # NOTE: currently -Os have issues with gcc3 and K6* arch's 116 # NOTE: currently -Os have issues with gcc3 and K6* arch's
79 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks -fprefetch-loop-arrays" 117 export UNSTABLE_FLAGS="-Os -O3 -freorder-blocks"
80 return 0 118 return 0
119}
120
121# inverted filters for hardened compiler. This is trying to unpick
122# the hardened compiler defaults.
123_filter-hardened() {
124 local f
125 for f in "$@" ; do
126 case "${f}" in
127 # Ideally we should only concern ourselves with PIE flags,
128 # not -fPIC or -fpic, but too many places filter -fPIC without
129 # thinking about -fPIE.
130 -fPIC|-fpic|-fPIE|-fpie|-Wl,pie|-pie)
131 gcc-specs-pie || continue
132 is-flagq -nopie || append-flags -nopie;;
133 -fstack-protector)
134 gcc-specs-ssp || continue
135 is-flagq -fno-stack-protector || append-flags -fno-stack-protector;;
136 -fstack-protector-all)
137 gcc-specs-ssp-to-all || continue
138 is-flagq -fno-stack-protector-all || append-flags -fno-stack-protector-all;;
139 esac
140 done
141}
142
143# Remove occurrences of strings from variable given in $1
144# Strings removed are matched as globs, so for example
145# '-O*' would remove -O1, -O2 etc.
146_filter-var() {
147 local f x VAR VAL
148 declare -a new
149
150 VAR=$1
151 shift
152 eval VAL=\${${VAR}}
153 for f in ${VAL}; do
154 for x in "$@"; do
155 # Note this should work with globs like -O*
156 [[ ${f} == ${x} ]] && continue 2
157 done
158 eval new\[\${\#new\[@]}]=\${f}
159 done
160 eval export ${VAR}=\${new\[*]}
81} 161}
82 162
83filter-flags() { 163filter-flags() {
84 for x in "$@" ; do 164 _filter-hardened "$@"
85 case "${x}" in 165 _filter-var CFLAGS "$@"
86 -fPIC|-fpic|-fPIE|-fpie|-pie) etexec-flags;; 166 _filter-var CXXFLAGS "$@"
87 -fstack-protector|-fstack-protector-all) fstack-flags;;
88 *) ;;
89 esac
90 done
91
92 # we do this fancy spacing stuff so as to not filter
93 # out part of a flag ... we want flag atoms ! :D
94 CFLAGS=" ${CFLAGS} "
95 CXXFLAGS=" ${CXXFLAGS} "
96 for x in "$@" ; do
97 CFLAGS="${CFLAGS// ${x} / }"
98 CXXFLAGS="${CXXFLAGS// ${x} / }"
99 done
100 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}"
101 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}"
102 return 0 167 return 0
103} 168}
104 169
105filter-lfs-flags() { 170filter-lfs-flags() {
171 [[ -n $@ ]] && die "filter-lfs-flags takes no arguments"
106 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE 172 filter-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
107} 173}
108 174
175append-lfs-flags() {
176 [[ -n $@ ]] && die "append-lfs-flags takes no arguments"
177 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
178}
179
109append-flags() { 180append-flags() {
181 [[ -z $* ]] && return 0
110 export CFLAGS="${CFLAGS} $@" 182 export CFLAGS="${CFLAGS} $*"
111 export CXXFLAGS="${CXXFLAGS} $@" 183 export CXXFLAGS="${CXXFLAGS} $*"
112 [ "`is-flag -fno-stack-protector`" -o "`is-flag -fno-stack-protector-all`" ] && fstack-flags
113 return 0 184 return 0
114} 185}
115 186
116replace-flags() { 187replace-flags() {
117 # we do this fancy spacing stuff so as to not filter 188 [[ $# != 2 ]] \
118 # out part of a flag ... we want flag atoms ! :D 189 && echo && eerror "Usage: replace-flags <old flag> <new flag>" \
119 CFLAGS=" ${CFLAGS} " 190 && die "replace-flags takes 2 arguments, not $#"
120 CXXFLAGS=" ${CXXFLAGS} " 191
121 CFLAGS="${CFLAGS// ${1} / ${2} }" 192 local f fset
122 CXXFLAGS="${CXXFLAGS// ${1} / ${2} }" 193 declare -a new_CFLAGS new_CXXFLAGS
123 CFLAGS="${CFLAGS:1:${#CFLAGS}-2}" 194
124 CXXFLAGS="${CXXFLAGS:1:${#CXXFLAGS}-2}" 195 for fset in CFLAGS CXXFLAGS; do
196 # Looping over the flags instead of using a global
197 # substitution ensures that we're working with flag atoms.
198 # Otherwise globs like -O* have the potential to wipe out the
199 # list of flags.
200 for f in ${!fset}; do
201 # Note this should work with globs like -O*
202 [[ ${f} == ${1} ]] && f=${2}
203 eval new_${fset}\[\${\#new_${fset}\[@]}]=\${f}
204 done
205 eval export ${fset}=\${new_${fset}\[*]}
206 done
207
125 return 0 208 return 0
126} 209}
127 210
128replace-cpu-flags() { 211replace-cpu-flags() {
129 local newcpu="$1" ; shift 212 local newcpu="$#" ; newcpu="${!newcpu}"
130 local oldcpu="" 213 while [ $# -gt 1 ] ; do
131 for oldcpu in "$@" ; do 214 # quote to make sure that no globbing is done (particularly on
215 # ${oldcpu} prior to calling replace-flags
132 replace-flags -march=${oldcpu} -march=${newcpu} 216 replace-flags "-march=${1}" "-march=${newcpu}"
133 replace-flags -mcpu=${oldcpu} -mcpu=${newcpu} 217 replace-flags "-mcpu=${1}" "-mcpu=${newcpu}"
134 replace-flags -mtune=${oldcpu} -mtune=${newcpu} 218 replace-flags "-mtune=${1}" "-mtune=${newcpu}"
219 shift
135 done 220 done
136 return 0 221 return 0
137} 222}
138 223
139is-flag() { 224is-flagq() {
225 local x
226
140 for x in ${CFLAGS} ${CXXFLAGS} ; do 227 for x in ${CFLAGS} ${CXXFLAGS} ; do
228 # Note this should work with globs like -mcpu=ultrasparc*
141 if [ "${x}" == "$1" ] ; then 229 if [[ ${x} == ${1} ]]; then
142 echo true
143 return 0 230 return 0
144 fi 231 fi
145 done 232 done
146 return 1 233 return 1
147} 234}
148 235
236is-flag() {
237 if is-flagq ${1}; then
238 echo true
239 return 0
240 fi
241 return 1
242}
243
244is-ldflagq() {
245 local x
246
247 for x in ${LDFLAGS} ; do
248 # Note this should work with globs like -mcpu=ultrasparc*
249 if [[ ${x} == ${1} ]]; then
250 return 0
251 fi
252 done
253 return 1
254}
255
256is-ldflag() {
257 if is-ldflagq ${1}; then
258 echo true
259 return 0
260 fi
261 return 1
262}
263
149filter-mfpmath() { 264filter-mfpmath() {
265 local orig_mfpmath new_math prune_math
266
150 # save the original -mfpmath flag 267 # save the original -mfpmath flag
151 local orig_mfpmath="`get-flag -mfpmath`" 268 orig_mfpmath="`get-flag -mfpmath`"
152 # get the value of the current -mfpmath flag 269 # get the value of the current -mfpmath flag
153 local new_math=" `get-flag mfpmath | tr , ' '` " 270 new_math=" `get-flag mfpmath | tr , ' '` "
154 # figure out which math values are to be removed 271 # figure out which math values are to be removed
155 local prune_math="" 272 prune_math=""
156 for prune_math in "$@" ; do 273 for prune_math in "$@" ; do
157 new_math="${new_math/ ${prune_math} / }" 274 new_math="${new_math/ ${prune_math} / }"
158 done 275 done
159 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`" 276 new_math="`echo ${new_math:1:${#new_math}-2} | tr ' ' ,`"
160 277
169 fi 286 fi
170 return 0 287 return 0
171} 288}
172 289
173strip-flags() { 290strip-flags() {
291 local x y flag NEW_CFLAGS NEW_CXXFLAGS
292
174 setup-allowed-flags 293 setup-allowed-flags
175 294
176 local NEW_CFLAGS="" 295 local NEW_CFLAGS=""
177 local NEW_CXXFLAGS="" 296 local NEW_CXXFLAGS=""
178 297
179 # Allow unstable C[XX]FLAGS if we are using unstable profile ... 298 # Allow unstable C[XX]FLAGS if we are using unstable profile ...
180 if [ `has ~${ARCH} ${ACCEPT_KEYWORDS}` ] ; then 299 if has ~$(tc-arch) ${ACCEPT_KEYWORDS} ; then
181 [ `use debug` ] && einfo "Enabling the use of some unstable flags"
182 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}" 300 ALLOWED_FLAGS="${ALLOWED_FLAGS} ${UNSTABLE_FLAGS}"
183 fi 301 fi
184 302
185 set -f 303 set -f # disable pathname expansion
186 304
187 for x in ${CFLAGS} 305 for x in ${CFLAGS}; do
188 do
189 for y in ${ALLOWED_FLAGS} 306 for y in ${ALLOWED_FLAGS}; do
190 do
191 flag=${x%%=*} 307 flag=${x%%=*}
192 if [ "${flag%%${y}}" = "" ] 308 if [ "${flag%%${y}}" = "" ] ; then
193 then
194 NEW_CFLAGS="${NEW_CFLAGS} ${x}" 309 NEW_CFLAGS="${NEW_CFLAGS} ${x}"
195 break 310 break
196 fi 311 fi
197 done 312 done
198 done 313 done
199 314
200 for x in ${CXXFLAGS} 315 for x in ${CXXFLAGS}; do
201 do
202 for y in ${ALLOWED_FLAGS} 316 for y in ${ALLOWED_FLAGS}; do
203 do
204 flag=${x%%=*} 317 flag=${x%%=*}
205 if [ "${flag%%${y}}" = "" ] 318 if [ "${flag%%${y}}" = "" ] ; then
206 then
207 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}" 319 NEW_CXXFLAGS="${NEW_CXXFLAGS} ${x}"
208 break 320 break
209 fi 321 fi
210 done 322 done
211 done 323 done
216 fi 328 fi
217 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then 329 if [ "${CXXFLAGS/-O}" != "${CXXFLAGS}" -a "${NEW_CXXFLAGS/-O}" = "${NEW_CXXFLAGS}" ]; then
218 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2" 330 NEW_CXXFLAGS="${NEW_CXXFLAGS} -O2"
219 fi 331 fi
220 332
221 set +f 333 set +f # re-enable pathname expansion
222
223 [ `use debug` ] \
224 && einfo "CFLAGS=\"${NEW_CFLAGS}\"" \
225 && einfo "CXXFLAGS=\"${NEW_CXXFLAGS}\""
226 334
227 export CFLAGS="${NEW_CFLAGS}" 335 export CFLAGS="${NEW_CFLAGS}"
228 export CXXFLAGS="${NEW_CXXFLAGS}" 336 export CXXFLAGS="${NEW_CXXFLAGS}"
229 return 0 337 return 0
230} 338}
231 339
340test-flag-PROG() {
341 local comp=$1
342 local flags="$2"
343
344 [[ -z ${comp} || -z ${flags} ]] && \
345 return 1
346
347 local PROG=$(tc-get${comp})
348 ${PROG} ${flags} -S -o /dev/null -xc /dev/null \
349 > /dev/null 2>&1
350}
351
352# Returns true if C compiler support given flag
353test-flag-CC() { test-flag-PROG "CC" "$1"; }
354
355# Returns true if C++ compiler support given flag
356test-flag-CXX() { test-flag-PROG "CXX" "$1"; }
357
358test-flags-PROG() {
359 local comp=$1
360 local flags
361 local x
362
363 shift
364
365 [[ -z ${comp} ]] && \
366 return 1
367
368 for x in "$@" ; do
369 test-flag-${comp} "${x}" && flags="${flags} ${x}"
370 done
371
372 echo "${flags}"
373
374 # Just bail if we dont have any flags
375 [[ -n ${flags} ]]
376}
377
378# Returns (echo's) the given flags supported by the C compiler
379test-flags-CC() { test-flags-PROG "CC" "$@"; }
380
381# Returns (echo's) the given flags supported by the C++ compiler
382test-flags-CXX() { test-flags-PROG "CXX" "$@"; }
383
384# Short-hand that should hopefully work for both C and C++ compiler, but
385# its really only present due to the append-flags() abomination.
386test-flags() { test-flags-CC "$@"; }
387
388# Depriciated, use test-flags()
232test_flag() { 389test_flag() {
233 if gcc -S -xc "$@" -o /dev/null /dev/null >/dev/null 2>&1; then 390 ewarn "test_flag: deprecated, please use test-flags()!" >&2
234 echo "$@" 391
392 test-flags-CC "$@"
393}
394
395test_version_info() {
396 if [[ $($(tc-getCC) --version 2>&1) == *$1* ]]; then
235 return 0 397 return 0
236 fi 398 else
237 return 1 399 return 1
400 fi
238} 401}
239 402
240strip-unsupported-flags() { 403strip-unsupported-flags() {
404 local x NEW_CFLAGS NEW_CXXFLAGS
405
241 for x in ${CFLAGS} ; do 406 for x in ${CFLAGS} ; do
242 NEW_CFLAGS=${NEW_CFLAGS}" ""`test_flag ${x}`" 407 NEW_CFLAGS="${NEW_CFLAGS} $(test-flags ${x})"
243 done 408 done
244 for x in ${CXXFLAGS} ; do 409 for x in ${CXXFLAGS} ; do
245 NEW_CXXFLAGS=${NEW_CXXFLAGS}" ""`test_flag ${x}`" 410 NEW_CXXFLAGS="${NEW_CXXFLAGS} $(test-flags ${x})"
246 done 411 done
247 412
248 export CFLAGS="${NEW_CFLAGS}" 413 export CFLAGS=${NEW_CFLAGS}
249 export CXXFLAGS="${NEW_CXXFLAGS}" 414 export CXXFLAGS=${NEW_CXXFLAGS}
250} 415}
251 416
252get-flag() { 417get-flag() {
418 local f findflag="$1"
419
253 # this code looks a little flaky but seems to work for 420 # this code looks a little flaky but seems to work for
254 # everything we want ... 421 # everything we want ...
255 # for example, if CFLAGS="-march=i686": 422 # for example, if CFLAGS="-march=i686":
256 # `get-flags -march` == "-march=i686" 423 # `get-flag -march` == "-march=i686"
257 # `get-flags march` == "i686" 424 # `get-flag march` == "i686"
258 local findflag="$1"
259 for f in ${CFLAGS} ${CXXFLAGS} ; do 425 for f in ${CFLAGS} ${CXXFLAGS} ; do
260 if [ "${f/${findflag}}" != "${f}" ] ; then 426 if [ "${f/${findflag}}" != "${f}" ] ; then
261 echo "${f/-${findflag}=}" 427 printf "%s\n" "${f/-${findflag}=}"
262 return 0 428 return 0
263 fi 429 fi
264 done 430 done
265 return 1 431 return 1
266} 432}
267 433
434# DEPRECATED - use gcc-specs-relro or gcc-specs-now from toolchain-funcs
435has_hardened() {
436 ewarn "has_hardened: deprecated, please use gcc-specs-{relro,now}()!" >&2
437
438 test_version_info Hardened && return 0
439 # The specs file wont exist unless gcc has GCC_SPECS support
440 [[ -f ${GCC_SPECS} && ${GCC_SPECS} != ${GCC_SPECS/hardened/} ]]
441}
442
443# DEPRECATED - use gcc-specs-pie from toolchain-funcs
444# indicate whether PIC is set
268has_pic() { 445has_pic() {
269 [ "${CFLAGS/-fPIC}" != "${CFLAGS}" ] && return 0 446 ewarn "has_pic: deprecated, please use gcc-specs-pie()!" >&2
270 [ "${CFLAGS/-fpic}" != "${CFLAGS}" ] && return 0 447
271 [ has_version sys-devel/hardened-gcc ] && return 0 448 [[ ${CFLAGS/-fPIC} != ${CFLAGS} || \
272 [ ! -z "`${CC/ .*/} --version| grep pie`" ] && return 0 449 ${CFLAGS/-fpic} != ${CFLAGS} ]] || \
450 gcc-specs-pie
451}
452
453# DEPRECATED - use gcc-specs-pie from toolchain-funcs
454# indicate whether PIE is set
455has_pie() {
456 ewarn "has_pie: deprecated, please use gcc-specs-pie()!" >&2
457
458 [[ ${CFLAGS/-fPIE} != ${CFLAGS} || \
459 ${CFLAGS/-fpie} != ${CFLAGS} ]] || \
460 gcc-specs-pie
461}
462
463# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
464# indicate whether code for SSP is being generated for all functions
465has_ssp_all() {
466 ewarn "has_ssp_all: deprecated, please use gcc-specs-ssp()!" >&2
467
468 # note; this matches only -fstack-protector-all
469 [[ ${CFLAGS/-fstack-protector-all} != ${CFLAGS} || \
470 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP_ALL__) ]] || \
471 gcc-specs-ssp-all
472}
473
474# DEPRECATED - use gcc-specs-ssp from toolchain-funcs
475# indicate whether code for SSP is being generated
476has_ssp() {
477 ewarn "has_ssp: deprecated, please use gcc-specs-ssp()!" >&2
478
479 # note; this matches both -fstack-protector and -fstack-protector-all
480 [[ ${CFLAGS/-fstack-protector} != ${CFLAGS} || \
481 -n $(echo | $(tc-getCC) ${CFLAGS} -E -dM - | grep __SSP__) ]] || \
482 gcc-specs-ssp
483}
484
485has_m64() {
486 # this doesnt test if the flag is accepted, it tests if the flag
487 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
488 # please dont replace this function with test_flag in some future
489 # clean-up!
490
491 local temp="$(emktemp)"
492 echo "int main() { return(0); }" > "${temp}".c
493 MY_CC=$(tc-getCC)
494 ${MY_CC/ .*/} -m64 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
495 local ret=$?
496 rm -f "${temp}".c
497 [[ ${ret} != 1 ]] && return 0
273 return 1 498 return 1
274} 499}
275 500
276has_pie() { 501has_m32() {
277 [ "${CFLAGS/-fPIE}" != "${CFLAGS}" ] && return 0 502 # this doesnt test if the flag is accepted, it tests if the flag
278 [ "${CFLAGS/-fpie}" != "${CFLAGS}" ] && return 0 503 # actually -WORKS-. non-multilib gcc will take both -m32 and -m64!
279 [ has_version sys-devel/hardened-gcc ] && return 0 504 # please dont replace this function with test_flag in some future
280 [ ! -z "`${CC/ .*/} --version| grep pie`" ] && return 0 505 # clean-up!
506
507 [ "$(tc-arch)" = "amd64" ] && has_multilib_profile && return 0
508
509 local temp=$(emktemp)
510 echo "int main() { return(0); }" > "${temp}".c
511 MY_CC=$(tc-getCC)
512 ${MY_CC/ .*/} -m32 -o "$(emktemp)" "${temp}".c > /dev/null 2>&1
513 local ret=$?
514 rm -f "${temp}".c
515 [[ ${ret} != 1 ]] && return 0
281 return 1 516 return 1
282} 517}
283
284has_ssp() {
285 [ "${CFLAGS/-fstack-protector}" != "${CFLAGS}" ] && return 0
286 [ has_version sys-devel/hardened-gcc ] && return 0
287 [ ! -z "`${CC/ .*/} --version| grep ssp`" ] && return 0
288 return 1
289}
290 518
291replace-sparc64-flags() { 519replace-sparc64-flags() {
292 local SPARC64_CPUS="ultrasparc v9" 520 local SPARC64_CPUS="ultrasparc3 ultrasparc v9"
293 521
294 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ] 522 if [ "${CFLAGS/mtune}" != "${CFLAGS}" ]; then
295 then
296 for x in ${SPARC64_CPUS} 523 for x in ${SPARC64_CPUS}; do
297 do
298 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}" 524 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8}"
299 done 525 done
300 else 526 else
301 for x in ${SPARC64_CPUS} 527 for x in ${SPARC64_CPUS}; do
302 do
303 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 528 CFLAGS="${CFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
304 done 529 done
305 fi 530 fi
306 531
307 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ] 532 if [ "${CXXFLAGS/mtune}" != "${CXXFLAGS}" ]; then
308 then
309 for x in ${SPARC64_CPUS} 533 for x in ${SPARC64_CPUS}; do
310 do
311 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}" 534 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8}"
312 done 535 done
313 else 536 else
314 for x in ${SPARC64_CPUS} 537 for x in ${SPARC64_CPUS}; do
315 do
316 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}" 538 CXXFLAGS="${CXXFLAGS/-mcpu=${x}/-mcpu=v8 -mtune=${x}}"
317 done 539 done
318 fi 540 fi
541
542 export CFLAGS CXXFLAGS
319} 543}
320 544
321append-ldflags() { 545append-ldflags() {
546 [[ -z $* ]] && return 0
322 LDFLAGS="${LDFLAGS} $@" 547 export LDFLAGS="${LDFLAGS} $*"
323 return 0 548 return 0
324} 549}
325 550
551# Remove flags from LDFLAGS - it's up to the ebuild to filter
552# CFLAGS and CXXFLAGS via filter-flags if they need to.
326filter-ldflags() { 553filter-ldflags() {
327 # we do this fancy spacing stuff so as to not filter 554 _filter-var LDFLAGS "$@"
328 # out part of a flag ... we want flag atoms ! :D 555 return 0
329 LDFLAGS=" ${LDFLAGS} " 556}
557
558# Turn C style ldflags (-Wl,-foo) into straight ldflags - the results
559# are suitable for passing directly to 'ld'; note LDFLAGS is usually passed
560# to gcc where it needs the '-Wl,'.
561raw-ldflags() {
562 local x input="$@"
563 [[ -z ${input} ]] && input=${LDFLAGS}
564 set --
330 for x in "$@" ; do 565 for x in ${input} ; do
331 LDFLAGS="${LDFLAGS// ${x} / }" 566 x=${x#-Wl,}
567 set -- "$@" ${x//,/ }
332 done 568 done
333 LDFLAGS="${LDFLAGS:1:${#LDFLAGS}-2}" 569 echo "$@"
334 return 0
335} 570}
336 571
337etexec-flags() { 572# This is thanks to great work from Paul de Vrieze <gentoo-user@devrieze.net>,
338 has_pie || has_pic 573# bug #9016. Also thanks to Jukka Salmi <salmi@gmx.net> (bug #13907) for more
339 if [ $? == 0 ] ; then 574# fixes.
340 # strip -fPIC regardless if you've gotten this far 575#
341 strip-flags -fPIC -fpic -fPIE -fpie -pie 576# Export CFLAGS and CXXFLAGS that are compadible with gcc-2.95.3
342 if [ "`is-flag -yet_exec`" != "true" ]; then 577gcc2-flags() {
343 # If our compile support -yet_exec, append it now 578 if [[ $(tc-arch) == "x86" || $(tc-arch) == "amd64" ]] ; then
344 [ -z "`gcc -yet_exec -S -o /dev/null -xc /dev/null 2>&1`" ] \ 579 CFLAGS=${CFLAGS//-mtune=/-mcpu=}
345 && ( debug-print ">>> appending flags -yet_exec" ; \ 580 CXXFLAGS=${CXXFLAGS//-mtune=/-mcpu=}
346 append-flags -yet_exec ; append-ldflags -yet_exec )
347 fi 581 fi
348 fi
349}
350 582
351fstack-flags() { 583 replace-cpu-flags k6-{2,3} k6
352 has_ssp 584 replace-cpu-flags athlon{,-{tbird,4,xp,mp}} i686
353 if [ $? == 0 ] ; then 585
354 # strip -fstack-protector regardless if you've gotten this far 586 replace-cpu-flags pentium-mmx i586
355 strip-flags -fstack-protector -fstack-protector-all 587 replace-cpu-flags pentium{2,3,4} i686
356 if [ "`is-flag -yno_propolice`" != "true" ]; then 588
357 # If our compile support -yno_propolice, append it now 589 replace-cpu-flags ev6{7,8} ev6
358 [ -z "`gcc -yno_propolice -S -o /dev/null -xc /dev/null 2>&1`" ] \ 590
359 && ( debug-print ">>> appending flags -yno_propolice" ; \ 591 export CFLAGS CXXFLAGS
360 append-flags -yno_propolice ; append-ldflags -yno_propolice )
361 fi
362 fi
363} 592}
593
594# Gets the flags needed for "NOW" binding
595bindnow-flags() {
596 case $($(tc-getLD) -v 2>&1 </dev/null) in
597 *GNU* | *'with BFD'*) # GNU ld
598 echo "-Wl,-z,now" ;;
599 *Apple*) # Darwin ld
600 echo "-bind_at_load" ;;
601 *)
602 # Some linkers just recognize -V instead of -v
603 case $($(tc-getLD) -V 2>&1 </dev/null) in
604 *Solaris*) # Solaris accept almost the same GNU options
605 echo "-Wl,-z,now" ;;
606 esac
607 ;;
608 esac
609}

Legend:
Removed from v.1.43  
changed lines
  Added in v.1.106

  ViewVC Help
Powered by ViewVC 1.1.20